unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    procedure PlaySound(AResName: String);

  public

  end;

var
  Form1: TForm1;

implementation

uses
  LCLType, LazFileUtils, uplaysound;

{$R *.lfm}
{$R resource.res}

{ TForm1 }

{ Extract resource, save in temp folder and play the sound. }
procedure TForm1.PlaySound(AResName: String);
var
  stream: TResourceStream;
  player: TPlaySound;
  tmpFileName: String;
begin
  tmpFileName := AppendPathDelim(GetTempDir) + AResName + '.tmp';

  if not FileExists(tmpFileName) then begin
    stream := TResourceStream.Create(HInstance, AResName, RT_RCDATA);;
    try
      stream.SaveToFile(tmpFileName);
    finally
      stream.Free;
    end;
  end;

  player := TPlaySound.Create(nil);
  try
    player.SoundFile := tmpFileName;
    player.Execute;
  finally
    player.Free;
  end;
end;

// Play sound2 after timer has expired.
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  PlaySound('sound1');
  Timer1.Enabled := false;
end;

// Play sound1 immediately
procedure TForm1.Button1Click(Sender: TObject);
begin
   PlaySound('sound1');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

{ clean up temporary files }
procedure TForm1.FormDestroy(Sender: TObject);
var
  tmpFileName: String;
begin
  tmpFileName := AppendPathDelim(GetTempDir) + 'sound1.tmp';
  if FileExists(tmpFileName) then
    DeleteFile(tmpFileName);

  tmpFileName := AppendPathDelim(GetTempDir) + 'sound2.tmp';
  if FileExists(tmpFileName) then
    DeleteFile(tmpFileName);
end;

end.

